/*
**		main.c
*/
#include "deconv.h"

int ddt;
int cmp;
int vhs;
int bgc;
int wid;
#define L 1024
Uc xlog[L];
char name[256]="init";
char fn[256];
char fnjpg[256];
char fnyuv[256];
FILE *f;

Dt gamma12(Dt v){	// ~ pow(x/4095,2.222)
	v= (v - OFFSET)/4095.;
	if(v<0.) v= 0.; if(v>1.) v= 1.;
 
 	if(use_gamma){
#ifdef GAMMA
	if(v< LID*GRD) v/= GRD;
	else v= pow((v+EXX)/(1+EXX),GMM);
#else
	v= pow(v,GMM);
#endif
	}
	if(v<0.) v= 0.; if(v>1.) v= 1.;
	return v;
}

Dt igamma12(Dt v){	// ~ pow(x,0.45)*4095
	if(v<0.) v= 0.; if(v>1.) v= 1.;

	if(use_gamma){
#ifdef GAMMA
	if(v< LID) v*= GRD;
	else v= (1+EXX)*pow(v,IGM)-EXX;
#else
	v= pow(v,IGM);
#endif
	}
	v= 4095*v + OFFSET +.5;
	if(v<0.)v= 0.; if(v>4095.)v= 4095.;
	return v;
}
int
read_in_raw_file(Uc *in, char *n, int x, int y)	// Bayer GR../ BG... each 2 byte
{
	int len,i,j,z=x*y;

	Us (*inp)[x]= malloc(x*y*2);
	Uc (*iny)[x]= (Uc(*)[x])in;
	Uc (*cb)[x/2]= (Uc(*)[x/2])(in+z);
	Uc (*cr)[x/2]= (Uc(*)[x/2])(in+z+z/4);

	f= fopen(n, "rb");
	if(!f) { char na[256]; strcpy(na,n); strcat(na,".raw"); f= fopen(na,"rb"); }
	if(!f) { fprintf(stderr,"%s ropen err\n", n); return 1; }
	printf("x=%d,y=%d,z=%d\n",x,y,z);
	if((len= fread((Uc*)inp,1,z*2,f))<z*2) { fprintf(stderr,"%s read err len=%d\n",n,len); return 1; }
	fclose(f);

	for(j=0;j<y;j+=2)
	for(i=0;i<x;i+=2) {
		Dt g0= inp[j  ][i  ]/4095.; Dt r=  inp[j  ][i+1]/4095.;
		Dt b=  inp[j+1][i  ]/4095.; Dt g1= inp[j+1][i+1]/4095.;
		Dt g2= (g0+g1)/2;

		iny[j  ][i  ]= (0.7154*g0+0.0721*b+0.2125*r)*255;
		iny[j+1][i+1]= (0.7154*g1+0.0721*b+0.2125*r)*255;
		iny[j  ][i+1]= (0.7154*g2+0.0721*b+0.2125*r)*255;
		iny[j+1][i  ]= (0.7154*g2+0.0721*b+0.2125*r)*255;

		cb[j/2][i/2]= 128+(-0.386*g2+0.500*b-0.115*r)*256;
		cr[j/2][i/2]= 128+(-0.454*g2-0.046*b+0.500*r)*256;
	}
	free(inp);
	return 0;
}

int gw(FILE*f) { int c= getc(f)<<8; return c+getc(f); }

int jpg_size(char *n, int *sx, int *sy)
{
	int c; Uc *p= xlog;

	if(!(f= fopen(n,"rb"))){ fprintf(stderr,"jpg open err\n"); return 0; }

	while((c= getc(f))==255);
	if(c!=0xd8){ fprintf(stderr,"no jpg file?\n"); return 0; }

lp:	while((c=getc(f))!=255 && c!=EOF);
	if(c==EOF){ fprintf(stderr,"jpg read err\n"); return 0; }

	while((c= getc(f))==255);
	if((c&0xf0)!=0xc0) { fseek(f,gw(f)-2,SEEK_CUR); goto lp; } // not SOF

	if(getc(f)) goto lp;		// length high is not 0?
	if(getc(f)< 11) goto lp;	// length low (file is too short?)

	c= getc(f); if(c!= 8 && c!= 12) goto lp; // 8 bit or 12 bit?
	*sy= gw(f); *sx= gw(f);		// get size y and x

	fclose(f);
	return 1;
}

int is_jpg_file_name(char *c)
{
	int len= strlen(c);
	if(len<4) return 0;
	if(!strncmp(c+len-4,".JPG",4)
	|| !strncmp(c+len-4,".jpg",4)) return 1;
	return 0;
}

int is_yuv_file_name(char *c)
{
	int len= strlen(c);
	if(len<4) return 0;
	if(!strncmp(c+len-4,".YUV",4)
	|| !strncmp(c+len-4,".yuv",4)) return 1;
	return 0;
}
int is_raw_file_name(char *c)
{
	int len= strlen(c);
	if(len<4) return 0;
	if(!strncmp(c+len-4,".RAW",4)
	|| !strncmp(c+len-4,".raw",4)) return 1;
	return 0;
}

//-- usage and main --

void usage(char *c)
{
fprintf(stderr,"Usage: %s [-param value] file.[yuv|jpg] ...\n",c);
fprintf(stderr,"\t-param def.: -estm 3, -psfm 3, -accl 2, -loop 30,\n");
fprintf(stderr,"\t-size XsizexYsize (for YUV files, ex. 512x512)\n");
fprintf(stderr,"\t-quiet (no display to X and no print PSF), -cutof\n");
exit(1);
}

int main(int c, char **v)
{
	int len,i,sx=SX,sy=SY,sz= SX*SY*3/2;
	char *cm= *v;
	Uc *in,*ot;
	int from_jpg= 0;
	int from_yuv= 0;
	int c0,isx=sx,isy=sy;
	float ver= 1.1;
	int x= 0;

	c--; v++;
	while(c){
		     if(!strcmp(*v,"-estm")) { c--; estm=  atoi(*++v); }
		else if(!strcmp(*v,"-psfm")) { c--; psfm=  atoi(*++v); }
		else if(!strcmp(*v,"-accl")) { c--; accl=  atoi(*++v); }
		else if(!strcmp(*v,"-loop")) { c--; iloop= atoi(*++v); }
		else if(!strcmp(*v,"-quiet")) dispf= pre= prm= 0;
		else if(!strcmp(*v,"-cutof")){ c--; cutof= atoi(*++v); }
		else if(!strcmp(*v,"-v")) x= 1;
		else if(!strcmp(*v,"-size")) {
			c--; sscanf(*++v,"%dx%d",&sx,&sy); sz= sx*sy*3/2;
			printf("same size for YUV files: %dx%d\n",sx,sy); isx= sx; isy= sy;
		}
		else if(**v=='-'){ fprintf(stderr,"unknown option:%s\n",*v); usage(cm); }
		else break;
		c--; v++;
	}
	if(c==0) usage(cm);


	if(x) {
	printf("Deconvution demo (Ver: %4.2f)(Copyright Winbond Corp. Japan 2007)\n",ver);
	printf(" is going to process %d source file(s) below:\n\n",c);
	i= 1;
	c0= c;
	while(c--) {
		sx= isx; sy= isy;		// use initial size for yuv file
		strcpy(fn,*v++);		// get file name
		len= strlen(fn);		// length of file name 
		if(is_jpg_file_name(fn)) {
			if(!jpg_size(fn,&sx,&sy)) continue;
			printf("%3d: %s",i,fn); fn[len-4]= 0;	// JPG file
		} else if(is_yuv_file_name(fn)) {
			printf("%3d: %s",i,fn); fn[len-4]= 0;	// YUV file
		} else continue;
		printf("\t (size: %4d x %4d)",sx,sy);
		printf(" will output: %s_est.jpg\n",fn);
		i++;
	}
	c= c0; v-=c0;	// go back to the first argument.
	printf("\n");
	printf("Would you really deconvolute (y/n)? (def.n)\n");
	printf("(you can stop the sequence at anytime by pressing Cntrol-C)\n");
	if(getchar()!='y') return 0;
	}

	while(c--){
		from_jpg= from_yuv= 0;
		sx= isx; sy= isy;		// use initial size for yuv file
		strcpy(fn,*v++); strcpy(fnyuv,fn); strcpy(fnjpg,fn);
		len= strlen(fn);

		if(is_jpg_file_name(fn)) {	// ext is JPG or jpg
			fn[len-4]= fnyuv[len-4]= 0; strcat(fnyuv,".yuv");
fr_jpg:			if(!jpg_size(fnjpg,&sx,&sy)) continue;
			sprintf(name,"convert %s %s",fnjpg,fnyuv); system(name); from_jpg= 1;
			if(x) printf("Source JPEG %s (size %dx%d)\n",fnjpg,sx,sy);
		} else if(is_yuv_file_name(fn)) {	// ext is yuv or YUV
			fn[len-4]= fnjpg[len-4]= 0; strcat(fnjpg,".jpg"); from_yuv= 1;
			if(x) printf("Source YUV %s\n",fnyuv);
		} else if(is_raw_file_name(fn)) {	// ext is raw or RAW
			fn[len-4]= fnjpg[len-4]= 0; strcat(fnjpg,".jpg");
			if(x) printf("Source RAW %s\n",fnyuv);
		} else continue;

		sz= sx*sy*3/2;
		in= malloc(sz); ot= malloc(sz);
		if(from_jpg||from_yuv) { if(read_in_yuv_file(in,sz,fnyuv)) continue; }
		else {
			if(read_in_raw_file(in,fnyuv,sx,sy)) continue;
			write_out(in,sz,"tmp.yuv");
			sprintf(name, "convert -size %dx%d tmp.yuv %s_bef.jpg; rm tmp.yuv",sx,sy,fn);
			system(name);
		}
		memcpy(ot,in,sz);
		if(dispf){
			iwt(fnyuv,in,      12, 24,sx,sy,0);	// observed
			iwt("est",in,  24+512, 24,sx,sy,1);	// estimate
			iwt("psf",mat2,12,24, H, V,2);	// psf
		}
		if(cutof) {
			int x,y; peak_pos_x= peak_pos_y= 0;
			while(!(x=peak_pos_x) || !(y=peak_pos_y)){
				usleep(100000); wt(in,"get up-left pos");
			}
			cut_out(*v,x,y,512,512,ot); return 0;
		}
		if(from_jpg) {
			sprintf(name,"rm %s",fnyuv); system(name); if(x) printf("%s\n",name);
		}
		else if(from_yuv){
			sprintf(name, "convert -size %dx%d %s %s_bef.jpg",sx,sy,fnyuv,fn);
			system(name); if(x) printf("%s\n",name);
		}

		if(x)printf("deconvolution start\n");
		deconv(sx,sy,sz,mat2,in,ot);	// deconvolution proc
		if(x)printf("deconvolution end\n");

		write_out(ot,sz,"o.yuv");
		sprintf(name, "convert -quality 70 -size %dx%d o.yuv %s_est.jpg; rm o.yuv",sx,sy,fn);
		system(name);
		if(x) printf("%s\n",name);
		free(in); free(ot);
	}
	if(x) printf("%d file(s) done.\n",c0);
	return 0;
}
