/*
**
**	xi.c: yuv structure sif to XImage mapping functions
**
**
*/
#include "deconv.h"
#include "xi.h"
/*
**	expand(): expand displied XImage to real wider XImage
**
**	mutiplication parameter x2: 0,1,2,3,4
**	0: not multiplication, rational (variable expansion)
**	1: same size, 2-4: multiple 2-4
*/
expand(p1,q,wx,wy,lbp,zlinebuff,dx,wix,ddy,x2)
Uc *p1;
Ui *q;
Ui *zlinebuff;
	{
	Uc d;
	int i,j,sx,sy,x,y;
	int w= (wx>>2)<<lbp;

	if(x2==1){
		Ui *p= (Ui *)p1;
		int len= ((wix*wy)<<lbp)/sizeof(Ui);
		for(j=0;j<len;j+=4){
			q[j  ]= p[j  ]; q[j+1]=p[j+1];
			q[j+2]= p[j+2]; q[j+3]=p[j+3];
		}
	}
	else if(x2==2){
		for(j=0;j<wy;j+=2){ 
			if(lbp==0){
				Us *p= (Us *)p1;
				for(i=0;i<(dx>>1);i++){
					Ui d= p[i];
					d= (d&(255<<8))<<8 | (d&255);
					q[i+w]= q[i]= d|d<<8;
				}
			}
			else if(lbp==1) {
				Us *p= (Us *)p1;
				for(i=0;i<dx;i++){
					Ui d= p[i];
					q[i+w]= q[i]= d|d<<16;
				}
			}
			else if(lbp==2) {
				Ui *p= (Ui *)p1;
				for(i=0;i<dx;i++)
				 q[2*i+w+1]= q[2*i+w]= q[2*i+1]= q[2*i]= p[i];
			}
			p1+= dx<<lbp;
			q+= w*2;
		}
	}
	else if(x2==3){
		Ui *p= (Ui *)p1;
		int ix= (dx>>2)<<lbp;
		for(j=0;j<ddy;j++){ 
			int k;
			if(lbp==0) for(i=k=0;k<ix;k++,i+=3){
				Ui d= *p++;
				Uc d0= d; Uc d1= d>>8;
				Uc d2= d>>16; Uc d3= d>>24;
#ifdef LE
				q[i  ]= d1<<24 | d0*((1<<16)+257);
				q[i+1]= (d2<<16 | d1)*257;
				q[i+2]= d3*(((1<<16)+257)<<8) | d2;
#else
				q[i+2]= d1<<24 | d0*((1<<16)+257);
				q[i+1]= (d2<<16 | d1)*257;
				q[i  ]= d3*(((1<<16)+257)<<8) | d2;
#endif
			}
			else if(lbp==1) for(i=k=0;k<ix;k++,i+=3){
				Ui d= *p++;
#ifdef LE
				Us d0= d;
				Us d1= d>>16;
#else
				Us d1= d;
				Us d0= d>>16;
#endif
				q[i  ]= d0<<16|d0;
				q[i+1]= d1<<16|d0;
				q[i+2]= d1<<16|d1;
			}
			else if(lbp==2) for(i=k=0;k<ix;k++,i+=3){
				Ui d= *p++;
				q[i+2]= q[i+1]= q[i  ]= d;
			}
			for(k=0;k<w;k++) q[k+w*2]=q[k+w]=q[k];
			q+= w*3;
		}
	}
	else if(x2==4){
		Ui *p= (Ui *)p1;
		int wx1= (wix>>2)<<lbp;
		int wx2= (wix>>1)<<lbp;
		int wx3= wx2+wx1;
		int ix= dx<<lbp;
		for(j=0;j<ddy;j++){ 
			if(lbp==0) for(i=0;i<dx;i++){
				Ui d= p1[i];
				d|= d<<8;
				q[i]= d<<16 | d;
			}
			else if(lbp==1) for(i=0;i<dx;i++){
				Ui d= *((Us *)p1+i);
				q[2*i+1]= q[2*i]= d<<16 | d;
			}
			else if(lbp==2) for(i=0;i<dx;i++){
				q[4*i+3]= q[4*i+2]= q[4*i+1]= q[4*i]= p[i];
			}
			for(i=0;i<((wx>>2)<<lbp);i++)
				q[i+wx3]= q[i+wx2]= q[i+wx1]= q[i];
			p1+= ix;
			p+= (dx>>2)<<lbp;
			q+= wix<<lbp;
		}
	}
/* variable expansion */
	 else if(lbp==0){
		Uc *cc= (Uc *)zlinebuff;
		j= sy= y= 0;
		while(j<wy)
		  if(sy>=0){
			i= sx= x= 0;
			while(i<wx)
				if(sx>=0){ sx-= wx; d= p1[x++]; }
				else { sx+= dx; cc[i++]= d; }
			p1+= dx; sy-= wy;
		} else {
			for(i=0;i<(wx>>2);i++) q[i]= zlinebuff[i];
			q+= wix>>2; sy+= ddy; j++;
		}
	}
	 else if(lbp==1){
		Us d,*sp= (Us *)zlinebuff;
		Us *p11= (Us *)p1;
		j= sy= y= 0;
		while(j<wy)
		  if(sy>=0){
			i= sx= x= 0;
			while(i<wx)
				if(sx>=0){ sx-= wx; d= p11[x++]; }
				else { sx+= dx; sp[i++]= d; }
			p11+= dx; sy-= wy;
		} else {
			for(i=0;i<(wx>>1);i++) q[i]= zlinebuff[i];
			q+= wix>>1; sy+= ddy; j++;
		}
	}
	 else if(lbp==2){
		Ui d;
		Ui *p11= (Ui *)p1;
		j= sy= y= 0;
		while(j<wy)
		  if(sy>=0){
			i= sx= x= 0;
			while(i<wx)
				if(sx>=0){ sx-= wx; d= p11[x++]; }
				else { sx+= dx; zlinebuff[i++]= d; }
			p11+= dx; sy-= wy;
		} else {
			for(i=0;i<wx;i++) q[i]= zlinebuff[i];
			q+= wix; sy+= ddy; j++;
		}
	}
}



#define Simple4
/*
**
	m0   m1   m2   m3
	   c         c
	m4   m5   m6   m7

	m8   m9   ma   mb
	   c         c
	mc   md   me   mf
**
*/
#define M0	0
#define	M1	16
#define	M2	4
#define	M3	20
#define	M4	24
#define	M5	8
#define	M6	28
#define	M7	12
#define	M8	6
#define	M9	22
#define	MA	2
#define	MB	18
#define	MC	30
#define	MD	14
#define	ME	26
#define	MF	10

#define O 256
#define RGBD(l,M,S) (y=(l>>S)&255,(r[y+M-O]|g[y+M+O]|b[y+2*M-O])<<S)
		

disp0(Uc *sif,struct wa *w)
{
static int inv= 0;
Us *cb;
Ui *ip,*yp;
int i,j,hx,wx;
int wx2,hx2;
int y,u,v;
int brd=w->xys>>3;
Ui h,n,l,m;
Ui *r,*g,*b;
Ui a,c;

hx= w->dx>>2;
wx= w->wix>>2;
wx2= wx<<1;
hx2= hx<<1;
ip= (Ui *)dd;
yp= (Ui *)sif;
cb= (Us *)(sif+(w->xys>>2));

if(inv^=1)
for(j=0;j<w->wy;j+=4){
	i= wx;
	do{
		c= cb[brd];
		a= *cb++;
		u= (a>>8)&255; v= (c>>8)&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		l= yp[hx];
		m= *yp++;
		n = RGBD(m,M0,24); n+= RGBD(m,M1,16);
		h = RGBD(l,M4,24); h+= RGBD(l,M5,16);
		u= a&255; v= c&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		n+= RGBD(m,M2,8); n+= RGBD(m,M3,0);
		h+= RGBD(l,M6,8); h+= RGBD(l,M7,0);
		ip[wx]= h;
		*ip++ = n;
		}while(--i);
	yp+= hx; ip+= wx;
	i= wx;
	do{
		c= cb[brd];
		a= *cb++;
		u= (a>>8)&255; v= (c>>8)&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		l= yp[hx];
		m= *yp++;
		n = RGBD(m,M8,24); n+= RGBD(m,M9,16);
		h = RGBD(l,MC,24); h+= RGBD(l,MD,16);
		u= a&255; v= c&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		n+= RGBD(m,MA,8); n+= RGBD(m,MB,0);
		h+= RGBD(l,ME,8); h+= RGBD(l,MF,0);
		ip[wx]= h;
		*ip++ = n;
		}while(--i);
	yp+= hx; ip+= wx;
	}
else
for(j=0;j<w->wy;j+=4){
	i= wx;
	do{
		c= cb[brd];
		a= *cb++;
		u= (a>>8)&255; v= (c>>8)&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		l= yp[hx];
		m= *yp++;
		n = RGBD(m,(30-M0),24); n+= RGBD(m,(30-M1),16);
		h = RGBD(l,(30-M4),24); h+= RGBD(l,(30-M5),16);
		u= a&255; v= c&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		n+= RGBD(m,(30-M2),8); n+= RGBD(m,(30-M3),0);
		h+= RGBD(l,(30-M6),8); h+= RGBD(l,(30-M7),0);
		ip[wx]= h;
		*ip++ = n;
		}while(--i);
	yp+= hx; ip+= wx;
	i= wx;
	do{
		c= cb[brd];
		a= *cb++;
		u= (a>>8)&255; v= (c>>8)&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		l= yp[hx];
		m= *yp++;
		n = RGBD(m,(30-M8),24); n+= RGBD(m,(30-M9),16);
		h = RGBD(l,(30-MC),24); h+= RGBD(l,(30-MD),16);
		u= a&255; v= c&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		n+= RGBD(m,(30-MA),8); n+= RGBD(m,(30-MB),0);
		h+= RGBD(l,(30-ME),8); h+= RGBD(l,(30-MF),0);
		ip[wx]= h;
		*ip++ = n;
		}while(--i);
	yp+= hx; ip+= wx;
	}
}
/*
**	4x4 RGB dither enlarged
*/
#define O 256
#define RGB(M) (r[y+M-O]|g[y+M+O]|b[y+2*M-O])
disp02(Uc *sif, struct wa *w)
{
	Uc *cb;
	Us *yp;
	Ui *ip;
	int	i,j,hcs,wx,wy;
	int	wx2,wx3;
	int	brd=w->xys>>2;
	int	y,u,v,d;
	Ui	*r,*g,*b;
	Ui	l,m,t;

	hcs= w->dx>>1;
	wx= w->wix>>2;
	wx2= wx>>1;
	wx3= wx2+wx;
	wy= w->wy>>2;
	ip= (Ui *)dd;
	yp= (Us *)sif;
	cb= sif+w->xys;

	for(j=0;j<wy;j++){
		i= wx;
		do{
		v= cb[brd];
		u= *cb++;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		d= yp[hcs]; y= d>>8;
		t= RGB(MA);
		l= t<<16; m= t&0xffff0000;
		y= (Uc)d;
		t= RGB(M8);
		l|= t&0xffff; m|= t>>16;
		ip[wx3]= m;
		ip[wx2]= l;
		d= *yp++; y= d>>8;
		t= RGB(M2);
		l= t<<16; m= t&0xffff0000;
		y= (Uc)d;
		t= RGB(M0);
		l|= t&0xffff; m|= t>>16;
		ip[wx]= m;
		*ip++ = l;
		}while(--i);
		yp+= hcs; ip+= wx3;
		}
	}

/*
**	4x4 RGB dither 4x4 enlarged
*/
#ifdef LE
#define Q0 0
#define Q1 1
#else
#define Q0 1
#define Q1 0
#endif
disp04(Uc *sif, struct wa *w)
	{
	Us *yp;
	Uc *cb;
	Ui *ip;
	int	i,j,hcs,wx,wy;
	int	wx2,wx3;
	int	crd=w->xys>>2;
	int	y,u,v,d;
	Ui	*r,*g,*b;
	Us	yy;
	Ui	l,m,t;

	hcs= w->dx>>1;
	wx=  w->wix>>2;
	wx2= wx>>1;
	wx3= wx2+wx;
	wy= w->wy>>2;
	yp= (Us *)sif;
	ip= (Ui *)dd;
	cb= (Uc *)yp+w->xys;

	for(j=0;j<wy;j++){
	for(i=0;i<wx;i+=2){
		v= cb[crd+(i>>1)];
		u= cb[(i>>1)];
		r= Q.r+(v<<1); g= Q.g-u-v; b= Q.b+(u<<1);
		yy= yp[i>>1];
		y= (Uc)yy;
#ifdef Simple4
		t= RGB(M0);
		l= t>>16|t<<16;
		ip[wx3+i]= l; ip[wx2+i]= t;
		ip[wx+i]= t; ip[i] = l;
#else
		t= RGB(MA); l= t<<16; m= t&0xffff0000;
		t= RGB(M8); l|= t&0xffff; m|= t>>16;
		ip[wx3+i+Q0]= m; ip[wx2+i+Q0]= l;
		t= RGB(M2); l= t<<16; m= t&0xffff0000;
		t= RGB(M0); l|= t&0xffff; m|= t>>16;
		ip[wx+i+Q0]= m; ip[i+Q0] = l;
#endif
		y= yy>>8;
#ifdef Simple4
		t= RGB(M0); 
		l= t>>16|t<<16;
		ip[wx3+i+1]= l; ip[wx2+i+1]= t;
		ip[wx+i+1]= t; ip[i+1] = l;
#else
		y= yy>>8;
		t= RGB(MA); l= t<<16; m= t&0xffff0000;
		t= RGB(M8); l|= t&0xffff; m|= t>>16;
		ip[wx3+i+Q1]= m; ip[wx2+i+Q1]= l;
		t= RGB(M2); l= t<<16; m= t&0xffff0000;
		t= RGB(M0); l|= t&0xffff; m|= t>>16;
		ip[wx+i+Q1]= m; ip[i+Q1] = l;
#endif
		}
		if(j&1)cb+= hcs;
		ip+= w->wix;
		yp+= hcs;
		}
	}
/*
**	3x3 RGB dither 3x3 enlaged
*/
#define T(M) (r[y+M-O]|g[y+M+O]|b[y+M-O])
#ifdef LE
#define O0 0
#define O1 1
#define O2 2
#else
#define O0 2
#define O1 1
#define O2 0
#endif
disp03(Uc *sif, struct wa *w)
{
	Us *cb;
	Ui *ip;
	int	i,j,wx,wx2,brd= w->xys>>3;
#ifdef Long64
	Ul	*r,*g,*b,t,t2;
#else
	Ui	*r,*g,*b,t,t2;
#endif
	Ui	*yp,d,l,m,n;
	Ui	uu,vv;
	Uc	y,u,v;

	wx=  w->wix>>2;
	wx2= w->wix>>1;
	ip= (Ui *)dd;
	yp= (Ui *)sif;
	cb= (Us *)yp+(w->xys>>1);
	for(j=0;j<w->wy/3;j++){
		yp= (Ui *)(sif+j*w->dx);
		ip= (Ui *)(dd+3*j*w->wix);
	for(i=0;i<wx;i+=3,ip+=3){
		vv= *(cb+brd); uu= *cb++;
		u= uu; v= vv;
#ifdef Long64
		r= (Ul *)(&Q)+256+(v<<1);
		g= (Ul *)(&Q)+1024-u-v;
		b= (Ul *)(&Q)+(1024+768)+(u<<1);
		d= *yp++; y= d; t= RGB(0); l= t;
		m= t>>24; n= t>>40;
#else
		r= Q.r+(v<<1); g= Q.g-u-v; b= Q.b+(u<<1);
		d= *yp++; y= d; t= RGB(0); l= t;
		t= T(768*3); m= t<<8 | l>>24; n= t>>8;
#endif
		l&= 0xffffff; m&= 0xffffff;
		y= d>>8; t= RGB(0);
		*(ip+O0) = t<<24 | l;
		*(ip+wx+O0)= (      t&0xff000000) | m;
#ifdef Long64
		*(ip+wx2+O0)= ((t>>16)&0xff000000) | n;
		l= t>>8; m= t>>32; n= t>>48;
#else
		l= t>>8; t= T(768*3);
		*(ip+wx2+O0)= ((t&0xff00)<<16) | n;
		m= t; n= t>>16;
#endif
		l&=0xffff; m&= 0xffff;

		u= uu>>8; v= vv>>8;
#ifdef Long64
		r= (Ul *)(&Q)+256+(v<<1);
		g= (Ul *)(&Q)+1024-u-v;
		b= (Ul *)(&Q)+(1024+768)+(u<<1);
		y= d>>16; t= RGB(0);
		*(ip+O1)= (t&0xffff)<<16 | l;
		*(ip+wx +O1)= ((t>> 8)&0xffff0000) | m;
		*(ip+wx2+O1)= ((t>>24)&0xffff0000) | n;
		m= t>>40; l= t>>16; n= t>>56;
#else
		r= Q.r+(v<<1); g= Q.g-u-v; b= Q.b+(u<<1);
		y= d>>16; t= RGB(0);
		*(ip+O1)= (t&0xffff)<<16 | l;
		t2= T(768*3);
		*(ip+wx +O1)= t2<<24 | ((t>>8)&0xff0000) | m;
		*(ip+wx2+O1)= ((t2<<8)&0xffff0000) | n;
		l= t>>16; m= t2>>8; n= t2>>24;
#endif
		l&=255; m&=255;
		y= d>>24; t= RGB(0);
		*(ip+O2)= t<<8 | l;
#ifdef Long64
		*(ip+wx +O2)= ((t>>16)&0xffffff00) | m;
		*(ip+wx2+O2)= ((t>>32)&0xffffff00) | n;
#else
		t2= T(768*3);
		*(ip+wx +O2)= (t2&0xffff)<<16 | ((t>>16)&0xff00) | m;
		*(ip+wx2+O2)= (t2&0xffffff00) | n;
#endif
		}
		if((j&1)==0)cb-= (w->dx>>2);
	}
}

disp3z(Uc *sif, struct wa *w)
{
	Uc	*cb,*cr;
	Us	*yp;
	Ui	*ip;
	int	i,j,hcs,wx,wy,wy1,wy2,wx1,wx2;
	int	u,v,d,l,m;
	Uc	y;
	Ui	*r,*g,*b,t;
	int	sx,sy;
	int	x,iy;

	wx= w->wix; wy= w->wiy;
	hcs= w->dx>>1;
	wx1= wx>>1; wx2= wx>>2;
	wy1= wy>>1; wy2= wy>>2;
	ip= (Ui *)dd;
	yp= (Us *)sif;
	cb= sif+w->xys; cr= cb+(w->xys>>2);

	sy= iy= 0;
	for(j=0;j<wy;){
		if(sy>=0){
			sy-= wy1;
			yp= (Us *)(sif+iy*w->dx);
			cb= sif+w->xys+hcs*(iy>>1); cr= cb+(w->xys>>2);
			ip= (Ui *)(dd+j*w->wx);
			sx= x= 0;
			for(i=0;i<wx1;){
				if(sx>=0){
					sx-= wx1; /* get uv,y */
					if((x++&1)==0){
						int x1= x>>1;
						u= cb[x1]; v= cr[x1];
				r= Q.r+(v<<1); g= Q.g-u-v; b= Q.b+(u<<1);
						d= yp[x1]; y= d;
					}
					else y= d>>8;
					t= RGB(0);
				} else {
					sx+= w->dx; /* save colorm */
					if(i++&1){
						l|= t<<16; m|= t&0xffff0000;
						*(ip+wx2)= m; *ip++ = l;
					} else {
						l= t&0xffff; m= t>>16;
					}
				}
			}
			iy++;
		} else {
			sy+= w->ddy; j+= 2;
			while(sy<0 && j<wy){
				ip= (Ui *)(dd+j*wx);
				for(i=0;i<wx1;i++) ip[i]= ip[i-wx1];
				sy+= w->ddy; j+= 2;
			}
		}
	}
}

/*
**	disp9.c
**	Full color
*/

#ifdef LE	/* Little-Endian Client */
#define	P0	0
#define	P1	8
#define	P2	16
#define	P3	24
#define C0	0
#define C8	8
#else		/* Big-Endian Client */
#define	P0	24
#define	P1	16
#define	P2	8
#define	P3	0
#define C0	8
#define C8	0
#endif

/*
#define rgb(u,v) r= Q.r+(v<<1);g= Q.g-u-v;b= Q.b+(u<<1)
*/
#define rgb(u,v) {int a= v+(v>>1);\
		int c= u+(u>>1);\
		r= Q.r+a;\
		g= Q.g-(a>>1)-(c>>2);\
		b= Q.b+c;}

extern Visual *vis;

void
disp90(Uc *sif,struct wa *w)
{
	Us *cb,*cr;
	Ui *ip,*yp;
	int i,j,hcs,wx,wy;

	hcs= w->dx>>2;
	wx= w->wx;
	wy= w->wy;
	ip= (Ui *)dd;
	yp= (Ui *)sif;
	cb= (Us *)(sif+w->xys);
	cr= (Us *)(sif+w->xys+(w->xys>>2));

	for(j=0;j<wy;j+=2){
	for(i=0;i<wx;i+=4){
		int y,u,v;
		Ui cbd,crd,*r,*g,*b,h,l,a,c,t;
		cbd= *cb++; crd= *cr++;
		u= (Uc)(cbd>>C0)-128; v= (Uc)(crd>>C0)-128;
		rgb(u,v);
		l= *(yp+hcs); h= *yp++;
		y= (Uc)(h>>P0); t= r[y]|g[y]|b[y]; XPutPixel(w->xi,i+0,j+0,t);
		y= (Uc)(h>>P1); t= r[y]|g[y]|b[y]; XPutPixel(w->xi,i+1,j+0,t);
		y= (Uc)(l>>P0); t= r[y]|g[y]|b[y]; XPutPixel(w->xi,i+0,j+1,t);
		y= (Uc)(l>>P1); t= r[y]|g[y]|b[y]; XPutPixel(w->xi,i+1,j+1,t);
		u= (Uc)(cbd>>C8)-128; v= (Uc)(crd>>C8)-128;
		rgb(u,v);
		y= (Uc)(h>>P2); t= r[y]|g[y]|b[y]; XPutPixel(w->xi,i+2,j+0,t);
		y= (Uc)(h>>P3); t= r[y]|g[y]|b[y]; XPutPixel(w->xi,i+3,j+0,t);
		y= (Uc)(l>>P2); t= r[y]|g[y]|b[y]; XPutPixel(w->xi,i+2,j+1,t);
		y= (Uc)(l>>P3); t= r[y]|g[y]|b[y]; XPutPixel(w->xi,i+3,j+1,t);
	}
	yp+= hcs; ip+= wx>>2;
	}
}

/*
**	256 True colors
*/
disp91(Uc *sif, struct wa *w)
	{
	Us *cb,*cr;
	Ui *ip,*yp;
	int	i,j,hcs,wx,wy;

	hcs= w->dx>>2;
	wx= w->wx>>2;
	wy= w->wy>>1;
	ip= (Ui *)dd;
	yp= (Ui *)sif;
	cb= (Us *)(sif+w->xys);
	cr= (Us *)(sif+w->xys+(w->xys>>2));

	for(j=0;j<wy;j++){
	for(i=0;i<wx;i++){
		int	y,u,v;
		Ui cbd,crd,*r,*g,*b,h,l,a,c;

		cbd= *cb++; crd= *cr++;
		u= (Uc)(cbd>>C0)-128; v= (Uc)(crd>>C0)-128;
		rgb(u,v);
		l= *(yp+hcs); h= *yp++;
		y= (Uc)(h>>P0); a = (r[y]|g[y]|b[y])<<P0;
		y= (Uc)(h>>P1); a|= (r[y]|g[y]|b[y])<<P1;
		y= (Uc)(l>>P0); c = (r[y]|g[y]|b[y])<<P0;
		y= (Uc)(l>>P1); c|= (r[y]|g[y]|b[y])<<P1;

		u= (Uc)(cbd>>C8)-128; v= (Uc)(crd>>C8)-128;
		rgb(u,v);
		y= (Uc)(h>>P2); a|= (r[y]|g[y]|b[y])<<P2;
		y= (Uc)(h>>P3); a|= (r[y]|g[y]|b[y])<<P3;
		y= (Uc)(l>>P2); c|= (r[y]|g[y]|b[y])<<P2;
		y= (Uc)(l>>P3); c|= (r[y]|g[y]|b[y])<<P3;
		*(ip+wx)= c;
		*ip++= a;
		}
		yp+= hcs; ip+= wx;
		}
	}

/*
**	65536 True Colors
*/
disp92(Uc *sif, struct wa *w)
{
	Uc *cb,*cr;
	Us *yp;
	Ui *ip;
	int	i,j,hcs,wx,wy;

	hcs= w->dx>>1;
	wx= w->wx>>1;
	wy= w->wy>>1;
	ip= (Ui *)dd;
	yp= (Us *)sif;
	cb= (Uc *)(sif+w->xys);
	cr= (Uc *)(sif+w->xys+(w->xys>>2));

	for(j=0;j<wy;j++){
	for(i=0;i<wx;i++){
		int	y,u,v;
		Ui *r,*g,*b,h,l,a,c;
		u= *cb++ -128; v= *cr++ -128;
		rgb(u,v);
		l= *(yp+hcs); h= *yp++;
		y= (Uc)(l>>C0); a = (r[y]|g[y]|b[y])<<C0*2;
		y= (Uc)(l>>C8); a|= (r[y]|g[y]|b[y])<<C8*2;
		y= (Uc)(h>>C0); c = (r[y]|g[y]|b[y])<<C0*2;
		y= (Uc)(h>>C8); c|= (r[y]|g[y]|b[y])<<C8*2;
		ip[wx]= a;
		*ip++ = c;
	}
		yp+= hcs; ip+= wx;
	}
}

void
disp922(Uc *sif,struct wa *w)
{
	Uc *cb; Us *yp; Ui *ip;
	int i,j,hcs,wx,wx2,wx3;

	hcs= w->dx>>1;
	wx=  w->wix/2;
	wx2= wx*2;
	wx3= wx*3;
	ip= (Ui *)dd;
	yp= (Us *)sif;
	cb= sif+w->xys;

	for(j=0;j<w->wy;j+=4){
	for(i=0;i<(w->wx>>1);i+=2){
		int	y,u,v,k=i>>1;
		Ui *r,*g,*b,a,c;
		Us d;
		u= cb[k]-128; v= cb[w->xys/4+k]-128;
		rgb(u,v);
		d= yp[k+hcs];
		y= (Uc)(d>>C0); a= r[y]|g[y]|b[y];
		y= (Uc)(d>>C8); c= r[y]|g[y]|b[y];
		a= a<<16|a; c= c<<16|c;
		ip[i+wx3]= ip[i+wx2]= a; ip[i+wx3+1]= ip[i+wx2+1]= c;
		d= yp[k];
		y= (Uc)(d>>C0); a= r[y]|g[y]|b[y];
		y= (Uc)(d>>C8); c= r[y]|g[y]|b[y];
		a= a<<16|a; c= c<<16|c;
		ip[i+wx]= ip[i]= a; ip[i+wx+1]= ip[i+1]= c;
	}
		yp+= w->dx; ip+= wx*4; cb+= hcs;
	}
}
/*
**	2^24 True Colors (4 byte pixel)
*/
disp93(Uc *sif, struct wa *w)
{
	Uc *cb,*cr;
	Us *yp;
	Ui *ip;
	int	i,j,hcs,wx,wy,wx2;

	hcs= w->dx>>1;
	wx= w->wx>>1;
	wx2= w->wx;
	wy= w->wy>>1;
	ip= (Ui *)dd;
	yp= (Us *)sif;
	cb= (Uc *)(sif+w->xys);
	cr= (Uc *)(sif+w->xys+(w->xys>>2));
	for(j=0;j<wy;j++){
	for(i=0;i<wx;i++){
		int	y,u,v;
		Ui *r,*g,*b,h,l;
		u= *cb++ -128; v= *cr++ -128;
		rgb(u,v);
		l= *(yp+hcs); h= *yp++;
		y= (Uc)(h>>C0); ip[0]=     r[y]|g[y]|b[y];
		y= (Uc)(h>>C8); ip[1]=     r[y]|g[y]|b[y];
		y= (Uc)(l>>C0); ip[wx2]=   r[y]|g[y]|b[y];
		y= (Uc)(l>>C8); ip[wx2+1]= r[y]|g[y]|b[y];
		ip+=2;
	}
		yp+= hcs; ip+= wx2;
	}
}

void
disp932(Uc *sif, struct wa *w)
{	 
	Uc *cb;
	Us *yp;   
	Ui *ip,*ip0;   
	int     i,j,hcs,wx,wx2,wx3;
	int	oy= w->dx  * w->posy/2 + w->posx/2;
	int	oc= w->dx/2*(w->posy/4)+ w->posx/4;

	hcs= w->dx>>1;
	wx= w->wix;						   
	wx2= wx*2;
	wx3= wx*3;
	ip= (Ui *)dd;

	yp= (Us *)(sif+oy);
	cb= sif+w->xys+oc;

	for(j=0;j<(w->wy>>2);j++){
		ip0= ip;
	for(i=0;i<(w->wx>>2);i++){
		int     y,u,v;
		Ui *r,*g,*b,h,l;
		u= cb[i]-128; v= cb[w->xys/4+i]-128;
		rgb(u,v);
		l= yp[hcs+i]; h= yp[i];
	y= (Uc)(h>>C0);ip[wx  ]= ip[wx+1]= ip[0]= ip[1]= r[y]|g[y]|b[y];
	y= (Uc)(h>>C8);ip[wx+2]= ip[wx+3]= ip[2]= ip[3]= r[y]|g[y]|b[y];
	y= (Uc)(l>>C0);ip[wx3 ]= ip[wx3+1]=ip[wx2  ]=ip[wx2+1]= r[y]|g[y]|b[y];
	y= (Uc)(l>>C8);ip[wx3+2]=ip[wx3+3]=ip[wx2+2]=ip[wx2+3]= r[y]|g[y]|b[y];
		ip+=4;
	}
		yp+= w->dx; ip= ip0+wx*4;
		cb+= hcs;
	}
}


extern int dep;
void
disp9(Uc *sif,struct wa *w)
{
	int boex= (ImageByteOrder(dpy)==
#ifdef LE
	MSBFirst
#else
	LSBFirst
#endif
	);

	if(dep<=8)disp91(sif,w);
	else if(boex) disp90(sif,w);
	else if(dep<=16){
		if(w->x2==2)	disp922(sif,w);
		else		disp92(sif,w);
	}
	else if(dep<=32){
		if(w->x2==2)	disp932(sif,w);
		else		disp93(sif,w);
	}
}

void
disp(Uc *sif,int x2,int ddt,struct wa *w)
{
	if(ddt==9)disp9(sif,w);
	else if(ddt==0){
	if(x2==1) disp0(sif,w);
	else if(x2==2)disp02(sif,w);
	else if(x2==3)disp03(sif,w);
	else if(x2==4)disp04(sif,w);
	else disp3z(sif,w);
	}
}

